/**************************************************************************
 *
 *-------------------------------------------------------------------------
 * Project : Short Read Assembler 
 *
 *-------------------------------------------------------------------------
 #######################################################################
 # This software has been created by Genome Research Limited (GRL).    #
 # GRL hereby grants permission to use, copy, modify and distribute    #
 # this software and its documentation for non-commercial purposes     #
 # without fee at the user's own risk on the basis set out below.      #
 # GRL neither undertakes nor accepts any duty whether contractual or  #
 # otherwise in connection with the software, its use or the use of    #
 # any derivative, and makes no representations or warranties, express #
 # or implied, concerning the software, its suitability, fitness for   #
 # a particular purpose or non-infringement.                           #
 # In no event shall the authors of the software or GRL be responsible #
 # or liable for any loss or damage whatsoever arising in any way      #
 # directly or indirectly out of the use of this software or its       #
 # derivatives, even if advised of the possibility of such damage.     #
 # Our software can be freely distributed under the conditions set out #
 # above, and must contain this copyright notice.                      #
 #######################################################################
 *
 *  Author : Yong Gu (ygu@sanger.ac.uk) 
 *
 *  Copyright (C) 2009 by Genome Research Limited, All rights reserved.
 *
 **************************************************************************/

#include <stdio.h>

#ifndef KMERP_H
#define KMERP_H

typedef struct _uniqKmerL {
	int nhits;	
	int kmerI; 	
	int *lnkKmHead;  
	int lnkKmSize;	 
	int reptKmer;  
} UniqKmerL;

typedef struct _fullKmerL {
	long kmerC;
	int readId;
	short readPos;	
	char rc;
	int uKmerId;   
} FullKmerL;

typedef struct _kmerDB {
	int kmerL;  
	int nFKmer; 
	int nUKmer; 
	FullKmerL *fKmer;
	UniqKmerL *uKmer;
	FullKmerL **fKmerSrt;
	int *lnkKmerL;  
	int totUsedKmer;
	long totDepth;
} KmerDB;

int intCmp(const void *v1, const void *v2);
int shtPath(UniqKmerL *uniqKmerP, int preKmerI, int curKmerI);
void read2kmerL(SeqDB *seqP, KmerDB *kmerDB);
void lnkKmerLst(KmerDB *kmerP);
void shtPathRmv(KmerDB *kmerP, Fastq *read, int qthresh);
void kmer2seq(long kmerC, char *cnsSeq, int kmerL, int rc, char *baseIndex);
void kmer2base(long kmerC, char *cnsSeq, int kmerL, int rc, char *baseIndex);
void reverseComplement(char *bases, long len);

#endif /* !defined(KMERP_H) */
