/**************************************************************************
 *
 *-------------------------------------------------------------------------
 * Project : Short Read Assembler 
 *
 *-------------------------------------------------------------------------
 #######################################################################
 # This software has been created by Genome Research Limited (GRL).    #
 # GRL hereby grants permission to use, copy, modify and distribute    #
 # this software and its documentation for non-commercial purposes     #
 # without fee at the user's own risk on the basis set out below.      #
 # GRL neither undertakes nor accepts any duty whether contractual or  #
 # otherwise in connection with the software, its use or the use of    #
 # any derivative, and makes no representations or warranties, express #
 # or implied, concerning the software, its suitability, fitness for   #
 # a particular purpose or non-infringement.                           #
 # In no event shall the authors of the software or GRL be responsible #
 # or liable for any loss or damage whatsoever arising in any way      #
 # directly or indirectly out of the use of this software or its       #
 # derivatives, even if advised of the possibility of such damage.     #
 # Our software can be freely distributed under the conditions set out #
 # above, and must contain this copyright notice.                      #
 #######################################################################
 *
 *  Author : Yong Gu (ygu@sanger.ac.uk) 
 *
 *  Copyright (C) 2009 by Genome Research Limited, All rights reserved.
 *
 **************************************************************************/

#include<stdlib.h>
#include <string.h>
#include"utils.h"

FILE *openfile(char *fname, char *attr)
{
        FILE *fp;
                                                                                                                  
        fp = fopen(fname, attr);
        if (fp == NULL){
                fprintf(stderr, "cannot open file %s\n", fname);
                exit(1);
        }
        return(fp);
}

int indexC(char *s, char *subs, int st)
{
	long n, k;
	char *ptr, *ptr1, *ptr2;
	long l1, l2;

	ptr = s + st;
	n = st;
	l1 = strlen(s);
	l2 = strlen(subs);
	while(n <= l1 - l2){
		ptr1 = ptr;
		ptr2 = subs;
		k = 0;
		while(*ptr2 == *ptr1){
			if(++k == l2){
				return(n);
			}
			ptr2++;
			ptr1++;
		}
		n++;
		ptr++;
	}
	return(-1);
}


int rindexC(char *s, char *subs, int st)
{
	long n;
	char *ptr, *ptr1, *ptr2;
	long l1, l2, l;

	l1 = strlen(s);
	l2 = strlen(subs);
	if(st + l2 > l1){
		ptr = s + l1 - 1;
		n = l1;
	}
	else {
		ptr = s + st - 1 + l2;
		n = st + l2;
	}
	while(n >= l2){
		ptr1 = ptr;
		ptr2 = subs+l2-1;
		l = l2;
		while(*ptr2-- == *ptr1--){
			if(--l == 0)return(n-l2);
		}
		n--;
		ptr--;
	}
	return(-1);
}


void printSpace(int n)
{
	int i;

	for(i=0;i<n;++i){
		printf(" ");
	}
}

